<template>
		<el-dialog
				width="30%"
				title="Edit Permission"
				:visible="dialogvisible"
				append-to-body
				@close="$emit('update:dialogvisible', false)">
			<el-form  id="edit-form" :model="content" :rules="rules" ref="content" label-width="120px" class="demo-content" v-if="content" v-loading="loading">
                <el-form-item class="" prop="display_name" label="Display Name" >
					<el-input @keyup.enter.native="submitForm('content')" type="text" placeholder="Enter permission name" v-model="content.display_name"></el-input>
				</el-form-item>
                <el-form-item class="" prop="description" label="Description" >
					<el-input @keyup.enter.native="submitForm('content')" type="text" placeholder="Enter description" v-model="content.description"></el-input>
				</el-form-item>

				<div >
					<div  class="btn-left" >
						<el-button class="text-red"
								   type="text"
								   @click="onRemove(detail.id, $event)">Delete
						</el-button>
					</div>
					<div class="btn-right">
						<el-button type="primary" @click="submitForm('content')" :disabled="loading" icon="mdi mdi-content-save-outline">Save changes</el-button>
					</div>
				</div>
			</el-form>
		</el-dialog>

</template>
<script>
	import $ from 'jquery'
    import {permission as permissionAPI} from '~/services/apis/index';

    export default {
        props: [ 'dialogvisible', 'detail', "list"],
        data() {
            return {
                content: {
                    id: this.detail.id,
                    display_name: this.detail.display_name,
                    description: this.detail.description,
                    url: '',
                    verb: '',
                    verbOptions: ['POST', 'GET', 'DELETE', 'PUT', 'PATCH', 'OPTION']
                },
                rules: {
                    display_name: [
                        { required: true, message: 'Please input permission name', trigger: 'blur' },
                        { max: 255, message: 'Length must be less than 256', trigger: 'blur' }
                    ]
                },
                loading: false
            };
        },
        methods: {
            submitForm(formName) {
                if(!this.$refs[formName]) return false;
                this.$refs[formName].validate((valid) => {
                    if (valid) {
                        this.loading = true;
                        this.submit();
                    } else {
                        this.loading = false;
                        return false;
                    }
                });
            },
            resetForm(formName) {
                if(!this.$refs[formName]) return;
                this.$refs[formName].resetFields();
            },
            submit() {
                permissionAPI.updatePermission(this.detail.id, this.content)
                    .then((res)=>{
                        let index = this.list.findIndex(item => item.id == this.detail.id);
                        this.list[index].display_name = this.content.display_name;
                        this.list[index].description = this.content.description;
                        this.loading = false;
                        this.$notify({
                            title: 'Success',
                            message: 'Update permission successfully!',
                            type: 'success'
                        });
                        this.$emit('update:dialogvisible', false);
                    })
                    .catch(()=>{
                        this.$notify.error({
                            title: 'Error',
                            message: 'Cannot update permission'
                        });
                        this.loading = false;
                    });
            },
			getDetail(){
                return {
					display_name: this.detail.display_name,
                    description: this.detail.description
				};
			},
            resetDialog(){
                this.resetForm("content");
            },
            onRemove(){
                this.$confirm('Are you sure you want to delete item?', 'Warning', {
                    confirmButtonText: 'Yes',
                    cancelButtonText: 'Cancel',
                    type: 'warning',
                    center: true
                }).then(() => {
                    this.loading = true;
                    permissionAPI.removePermission(this.detail.id)
                        .then((res)=>{
                            this.$notify({
                                title: 'Success',
                                message: 'Delete permission successfully!',
                                type: 'success'
                            });
                            let index = this.list.findIndex(item => item.id == this.detail.id);
                            this.list.splice(index,1);
                            this.$emit('update:dialogvisible', false);
                            this.loading = false;
                        })

                        .catch(()=>{
                            this.$notify.error({
                                title: 'Error',
                                message: 'Cannot delete permission'
                            });
                            this.loading = false;
                        })
                }).catch((err) => {
                    console.log(err);
                });

            }
        },
		mounted(){
            let that = this;
            $('body').on("submit", "#edit-form", function(e){
                event.preventDefault();
                that.submitForm('content');
            });
		},
        watch: {
            detail: function () {
                this.content = this.detail;
            },
            dialogvisible: function () {
                this.resetDialog();
                this.content = this.getDetail();
            }
        },

    }
</script>
